module     p0_dd_emnebardu_d23h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity0/d23h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d23
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd23h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3+k2-k6-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t2 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      t3 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      t4 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb23n15+t1*abb23n36+abb23n22*dotproduct(qshift, qshift)+a&
         &bb23n27*(spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshif&
         &t(3)-spvak3k1(4)*qshift(4))+abb23n29*(spvak6k1(1)*qshift(1)-spvak6k1(2&
         &)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)*qshift(4))+abb23n30*dotp&
         &roduct(k1, qshift)+abb23n32*dotproduct(k5, qshift)+abb23n33*(spvak5k2(&
         &1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-spvak5k2(4)*q&
         &shift(4))+abb23n34*(spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5&
         &k4(3)*qshift(3)-spvak5k4(4)*qshift(4))+t1*t2*abb23n16+t1*t3*abb23n18+t&
         &1*t4*abb23n25)
         return
      end if
      t5 = spvak5k1(iv1)
      t6 = spvak3k2(iv1)
      t7 = spvak6k2(iv1)
      t8 = spvak6k4(iv1)
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb23n23+k5(iv1)*abb23n21+qshift(iv1)*abb23n31+spv&
         &ak3k1(iv1)*abb23n26+spvak5k2(iv1)*abb23n20+spvak5k4(iv1)*abb23n19+spva&
         &k6k1(iv1)*abb23n24+t5*abb23n17+t1*t6*abb23n28+t1*t7*abb23n35+t1*t8*abb&
         &23n37+t2*t5*abb23n37+t3*t5*abb23n35+t4*t5*abb23n28)
         return
      end if
      t1 = spvak5k1(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb23n22+spvak3k2(iv2)*t5*abb23n25+spv&
         &ak6k2(iv2)*t5*abb23n18+spvak6k4(iv2)*t5*abb23n16+t1*t6*abb23n25+t1*t7*&
         &abb23n18+t1*t8*abb23n16)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d23:
   subroutine     reconstruct_d23(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group1
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group1), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_23:
      coeffs%coeffs_23%c0 = derivative(czip)
      coeffs%coeffs_23%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_23%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_23%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_23%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_23%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_23%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_23%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_23%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_23%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_23%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_23%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_23%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_23%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_23%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_23:
   end subroutine reconstruct_d23
!---#] subroutine reconstruct_d23:
end module p0_dd_emnebardu_d23h0l1d
