module     p0_dd_emnebardu_d51h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity0/d51h0l1.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dd_emnebardu_groups, only: &
!           & sign => diagram51_sign, shift => diagram51_shift
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd51h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d51

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k6-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d51 = 0.0_ki
      d51 = (abb51n1+abb51n2*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)&
      &-Q(4)*spvak3k1(4))+abb51n3*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6&
      &k1(3)-Q(4)*spvak6k1(4))+abb51n4*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*s&
      &pvak3k2(3)-Q(4)*spvak3k2(4))+abb51n5*(Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q&
      &(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+abb51n6*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(&
      &3)-Q(4)*k1(4))+abb51n6*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb5&
      &1n7*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb51n8*(Q(1)*spvak5k2(&
      &1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+abb51n9*(Q(1)*spva&
      &k5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)))
      numerator = cmplx(real(d51, ki), aimag(d51), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd51h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d51

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k6-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d51 = 0.0_ki
      d51 = (abb51n1+abb51n2*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)&
      &-Q(4)*spvak3k1(4))+abb51n3*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6&
      &k1(3)-Q(4)*spvak6k1(4))+abb51n4*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*s&
      &pvak3k2(3)-Q(4)*spvak3k2(4))+abb51n5*(Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q&
      &(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+abb51n6*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(&
      &3)-Q(4)*k1(4))+abb51n6*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb5&
      &1n7*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb51n8*(Q(1)*spvak5k2(&
      &1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+abb51n9*(Q(1)*spva&
      &k5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)))

      numerator = cmplx(real(d51, ki), aimag(d51), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dd_emnebardu_d51h0l1
