module     p0_dd_emnebardu_d51h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity1/d51h1l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d51
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd51h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb51n11+abb51n12*(spvak3k2(1)*qshift(1)-spvak3k2(2)*qshif&
         &t(2)-spvak3k2(3)*qshift(3)-spvak3k2(4)*qshift(4))+abb51n13*(spvak6k2(1&
         &)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-spvak6k2(4)*qs&
         &hift(4))+abb51n14*(spvak3k5(1)*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k&
         &5(3)*qshift(3)-spvak3k5(4)*qshift(4))+abb51n15*(spvak6k5(1)*qshift(1)-&
         &spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-spvak6k5(4)*qshift(4))+abb&
         &51n16*dotproduct(k5, qshift)+abb51n17*dotproduct(k1, qshift)+abb51n17*&
         &dotproduct(k2, qshift)+abb51n18*(spvak1k2(1)*qshift(1)-spvak1k2(2)*qsh&
         &ift(2)-spvak1k2(3)*qshift(3)-spvak1k2(4)*qshift(4))+abb51n19*(spvak1k5&
         &(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-spvak1k5(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb51n17+k2(iv1)*abb51n17+k5(iv1)*abb51n16+spvak1k&
         &2(iv1)*abb51n18+spvak1k5(iv1)*abb51n19+spvak3k2(iv1)*abb51n12+spvak3k5&
         &(iv1)*abb51n14+spvak6k2(iv1)*abb51n13+spvak6k5(iv1)*abb51n15)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d51:
   subroutine     reconstruct_d51(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_51:
      coeffs%coeffs_51%c0 = derivative(czip)
      coeffs%coeffs_51%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_51%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_51%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_51%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_51:
   end subroutine reconstruct_d51
!---#] subroutine reconstruct_d51:
end module p0_dd_emnebardu_d51h1l1d
