module     p2_ddbar_emnebarcsbar_d31h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p2_ddbar_emnebarcsbar/helicity0/d31h0l1.f90
   ! generator: haggies (1.1)
   use p2_ddbar_emnebarcsbar_config, only: ki
   use p2_ddbar_emnebarcsbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p2_ddbar_emnebarcsbar_groups, only: &
!           & sign => diagram31_sign, shift => diagram31_shift
      use p2_ddbar_emnebarcsbar_globalsl1, only: epspow
      use p2_ddbar_emnebarcsbar_kinematics
      use p2_ddbar_emnebarcsbar_abbrevd31h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d31
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k2
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d31 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      t3 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t4 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))
      d31 = (t1*abb31n1+t2*abb31n2+t3*abb31n3+t4*abb31n4+t5*abb31n5+t6*abb31n6+t&
      &1*t5*abb31n9+t2*t6*abb31n7+t3*t6*abb31n10+t4*t5*abb31n8)
      numerator = cmplx(real(d31, ki), aimag(d31), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p2_ddbar_emnebarcsbar_globalsl1, only: epspow
      use p2_ddbar_emnebarcsbar_kinematics
      use p2_ddbar_emnebarcsbar_abbrevd31h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d31
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k2
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d31 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      t3 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t4 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))
      d31 = (t1*abb31n1+t2*abb31n2+t3*abb31n3+t4*abb31n4+t5*abb31n5+t6*abb31n6+t&
      &1*t5*abb31n9+t2*t6*abb31n7+t3*t6*abb31n10+t4*t5*abb31n8)

      numerator = cmplx(real(d31, ki), aimag(d31), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p2_ddbar_emnebarcsbar_d31h0l1
