module     p3_ud_emnebaruu_d59h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p3_ud_emnebaruu/helicity1/d59h1l1.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p3_ud_emnebaruu_groups, only: &
!           & sign => diagram59_sign, shift => diagram59_shift
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd59h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d59
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d59 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t2 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t3 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t4 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4))
      t5 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t6 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t7 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      d59 = (abb59n5*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+abb59n6*(Q(1)&
      &*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+t1*t2*abb59n1+t1*t4*abb59n13+t2*&
      &t3*abb59n2+t2*t5*abb59n2+t2*t6*abb59n3+t2*t7*abb59n4+t2*abb59n10*(Q(1)*sp&
      &vak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4))+t2*abb59n8*&
      &(Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))+t3*&
      &t4*abb59n11+t4*t5*abb59n11+t4*t6*abb59n12+t4*t7*abb59n14+t4*abb59n7*(Q(1)&
      &*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+t4*abb59&
      &n9*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)))
      numerator = cmplx(real(d59, ki), aimag(d59), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd59h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d59
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d59 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t2 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t3 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t4 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4))
      t5 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t6 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t7 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      d59 = (abb59n5*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+abb59n6*(Q(1)&
      &*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+t1*t2*abb59n1+t1*t4*abb59n13+t2*&
      &t3*abb59n2+t2*t5*abb59n2+t2*t6*abb59n3+t2*t7*abb59n4+t2*abb59n10*(Q(1)*sp&
      &vak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4))+t2*abb59n8*&
      &(Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))+t3*&
      &t4*abb59n11+t4*t5*abb59n11+t4*t6*abb59n12+t4*t7*abb59n14+t4*abb59n7*(Q(1)&
      &*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+t4*abb59&
      &n9*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)))

      numerator = cmplx(real(d59, ki), aimag(d59), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p3_ud_emnebaruu_d59h1l1
