module     p6_dubar_emnebarssbar_d31h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p6_dubar_emnebarssbar/helicity1/d31h1l1d.f90
   ! generator: haggies (1.1)
   use p6_dubar_emnebarssbar_config, only: ki
   use p6_dubar_emnebarssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d31
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p6_dubar_emnebarssbar_globalsl1, only: epspow
      use p6_dubar_emnebarssbar_kinematics
      use p6_dubar_emnebarssbar_abbrevd31h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb31n14
         return
      end if
      t1 = spvak2k6(iv1)
      t2 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb31n24+t1*abb31n23+t2*abb31n25)
         return
      end if
      t3 = spvak2k6(iv2)
      t4 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = (k1(iv1)*t3*abb31n17+k1(iv2)*t1*abb31n17+k3(iv1)*t3*abb31n1&
         &8+k3(iv2)*t1*abb31n18+k4(iv1)*t3*abb31n18+k4(iv2)*t1*abb31n18+spvak2k1&
         &(iv1)*t4*abb31n22+spvak2k1(iv2)*t2*abb31n22+spvak2k4(iv1)*t4*abb31n20+&
         &spvak2k4(iv2)*t2*abb31n20+spvak3k1(iv1)*t3*abb31n15+spvak3k1(iv2)*t1*a&
         &bb31n15+spvak3k4(iv1)*t3*abb31n16+spvak3k4(iv2)*t1*abb31n16+spvak5k1(i&
         &v1)*t3*abb31n21+spvak5k1(iv2)*t1*abb31n21+spvak5k4(iv1)*t3*abb31n19+sp&
         &vak5k4(iv2)*t1*abb31n19)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d31:
   subroutine     reconstruct_d31(coeffs)
      use p6_dubar_emnebarssbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_31:
      coeffs%coeffs_31%c0 = derivative(czip)
      coeffs%coeffs_31%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_31%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_31%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_31%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_31%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_31%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_31%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_31%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_31%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_31%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_31%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_31%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_31%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_31%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_31:
   end subroutine reconstruct_d31
!---#] subroutine reconstruct_d31:
end module p6_dubar_emnebarssbar_d31h1l1d
