module     p7_dubar_emnebargg_d47h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity0/d47h0l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d47
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd47h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t15 = dotproduct(k1, qshift)
      t16 = dotproduct(k3, qshift)
      t17 = dotproduct(k4, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t3 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t4 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb47n20+t1*abb47n30+t15*abb47n28+t16*abb47n29+t17*abb47n2&
         &9+t2*abb47n31+t3*abb47n36+abb47n27*dotproduct(qshift, qshift)+abb47n32&
         &*dotproduct(k2, qshift)+abb47n33*dotproduct(k5, qshift)+abb47n35*dotpr&
         &oduct(k6, qshift)+abb47n37*(spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2&
         &)-spvak2k6(3)*qshift(3)-spvak2k6(4)*qshift(4))+t1*t3*abb47n23+t15*t3*a&
         &bb47n24+t16*t3*abb47n25+t17*t3*abb47n25+t2*t3*abb47n21+t3*t4*abb47n22+&
         &t3*t5*abb47n26)
         return
      end if
      t6 = k1(iv1)
      t7 = k3(iv1)
      t8 = k4(iv1)
      t9 = spvak3k1(iv1)
      t10 = spvak3k4(iv1)
      t11 = spvak5k6(iv1)
      t12 = spvak2k1(iv1)
      t13 = spvak2k4(iv1)
      t14 = t11*abb47n25
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb47n32+k5(iv1)*abb47n33+k6(iv1)*abb47n35+qshift(&
         &iv1)*abb47n34+spvak2k6(iv1)*abb47n37+t10*abb47n30+t11*abb47n36+t14*t16&
         &+t14*t17+t6*abb47n28+t7*abb47n29+t8*abb47n29+t9*abb47n31+t1*t11*abb47n&
         &23+t10*t3*abb47n23+t11*t15*abb47n24+t11*t2*abb47n21+t11*t4*abb47n22+t1&
         &1*t5*abb47n26+t12*t3*abb47n26+t13*t3*abb47n22+t3*t6*abb47n24+t3*t7*abb&
         &47n25+t3*t8*abb47n25+t3*t9*abb47n21)
         return
      end if
      t1 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb47n27+k1(iv2)*t11*abb47n24+k3(iv2)*&
         &t11*abb47n25+k4(iv2)*t11*abb47n25+spvak2k1(iv2)*t11*abb47n26+spvak2k4(&
         &iv2)*t11*abb47n22+spvak3k1(iv2)*t11*abb47n21+spvak3k4(iv2)*t11*abb47n2&
         &3+t1*t10*abb47n23+t1*t12*abb47n26+t1*t13*abb47n22+t1*t6*abb47n24+t1*t7&
         &*abb47n25+t1*t8*abb47n25+t1*t9*abb47n21)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d47:
   subroutine     reconstruct_d47(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_47:
      coeffs%coeffs_47%c0 = derivative(czip)
      coeffs%coeffs_47%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_47%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_47%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_47%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_47%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_47%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_47%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_47%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_47%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_47%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_47%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_47%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_47%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_47%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_47:
   end subroutine reconstruct_d47
!---#] subroutine reconstruct_d47:
end module p7_dubar_emnebargg_d47h0l1d
