module     p7_dubar_emnebargg_d84h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity1/d84h1l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram84_sign, shift => diagram84_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd84h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d84
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d84 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = t4*t4
      t6 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t7 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t8 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t9 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t10 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t11 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t12 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t13 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t14 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t15 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d84 = (abb84n1+t1*abb84n14+t1*t1*abb84n31+t10*abb84n8+t2*abb84n16+t3*abb84&
      &n23+t4*abb84n6+t5*abb84n3+t6*abb84n4+t7*abb84n5+t8*abb84n56+t9*abb84n7+t1&
      &*t10*abb84n32+t1*t12*abb84n39+t1*t15*abb84n58+t1*t3*abb84n30+t1*t4*abb84n&
      &21+t1*t6*abb84n49+t1*t9*abb84n27+t10*t12*abb84n37+t10*t4*abb84n2+t10*t6*a&
      &bb84n12+t11*t4*abb84n38+t11*t5*abb84n18+t12*t2*abb84n25+t12*t3*abb84n40+t&
      &12*t4*abb84n26+t12*t7*abb84n24+t12*t9*abb84n29+t13*t5*abb84n44+t14*t4*abb&
      &84n46+t14*t5*abb84n47+t15*t2*abb84n57+t15*t4*abb84n55+t15*t5*abb84n65+t15&
      &*t7*abb84n59+t2*t3*abb84n33+t2*t4*abb84n22+t2*t5*abb84n15+t2*t6*abb84n50+&
      &t2*t9*abb84n28+t3*t4*abb84n34+t3*t5*abb84n15+t3*t6*abb84n11+t3*t7*abb84n3&
      &0+t3*t9*abb84n20+t4*t6*abb84n64+t4*t7*abb84n2+t4*t8*abb84n61+t4*t9*abb84n&
      &9+t5*t6*abb84n51+t5*t8*abb84n53+t6*t7*abb84n48+t6*t9*abb84n10+t1*t12*t4*a&
      &bb84n18+t1*t13*t4*abb84n42+t1*t15*t4*abb84n63+t1*t4*t6*abb84n52+t1*t4*t9*&
      &abb84n35+t10*t12*t4*abb84n17+t10*t15*t4*abb84n62+t10*t4*t6*abb84n54+t12*t&
      &3*t4*abb84n19+t12*t4*t9*abb84n45+t13*t2*t4*abb84n43+t13*t4*t7*abb84n41+t1&
      &4*t4*t9*abb84n60+t14*t5*t9*abb84n66+t15*t2*t4*abb84n62+t15*t3*t4*abb84n63&
      &+t15*t4*t7*abb84n63+t2*t4*t6*abb84n54+t2*t4*t9*abb84n36+t3*t4*t6*abb84n52&
      &+t3*t4*t9*abb84n36+t4*t6*t7*abb84n52+t4*t6*t9*abb84n13)
      numerator = cmplx(real(d84, ki), aimag(d84), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd84h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d84
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d84 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = t4*t4
      t6 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t7 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t8 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t9 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t10 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t11 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t12 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t13 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t14 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t15 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d84 = (abb84n1+t1*abb84n14+t1*t1*abb84n31+t10*abb84n8+t2*abb84n16+t3*abb84&
      &n23+t4*abb84n6+t5*abb84n3+t6*abb84n4+t7*abb84n5+t8*abb84n56+t9*abb84n7+t1&
      &*t10*abb84n32+t1*t12*abb84n39+t1*t15*abb84n58+t1*t3*abb84n30+t1*t4*abb84n&
      &21+t1*t6*abb84n49+t1*t9*abb84n27+t10*t12*abb84n37+t10*t4*abb84n2+t10*t6*a&
      &bb84n12+t11*t4*abb84n38+t11*t5*abb84n18+t12*t2*abb84n25+t12*t3*abb84n40+t&
      &12*t4*abb84n26+t12*t7*abb84n24+t12*t9*abb84n29+t13*t5*abb84n44+t14*t4*abb&
      &84n46+t14*t5*abb84n47+t15*t2*abb84n57+t15*t4*abb84n55+t15*t5*abb84n65+t15&
      &*t7*abb84n59+t2*t3*abb84n33+t2*t4*abb84n22+t2*t5*abb84n15+t2*t6*abb84n50+&
      &t2*t9*abb84n28+t3*t4*abb84n34+t3*t5*abb84n15+t3*t6*abb84n11+t3*t7*abb84n3&
      &0+t3*t9*abb84n20+t4*t6*abb84n64+t4*t7*abb84n2+t4*t8*abb84n61+t4*t9*abb84n&
      &9+t5*t6*abb84n51+t5*t8*abb84n53+t6*t7*abb84n48+t6*t9*abb84n10+t1*t12*t4*a&
      &bb84n18+t1*t13*t4*abb84n42+t1*t15*t4*abb84n63+t1*t4*t6*abb84n52+t1*t4*t9*&
      &abb84n35+t10*t12*t4*abb84n17+t10*t15*t4*abb84n62+t10*t4*t6*abb84n54+t12*t&
      &3*t4*abb84n19+t12*t4*t9*abb84n45+t13*t2*t4*abb84n43+t13*t4*t7*abb84n41+t1&
      &4*t4*t9*abb84n60+t14*t5*t9*abb84n66+t15*t2*t4*abb84n62+t15*t3*t4*abb84n63&
      &+t15*t4*t7*abb84n63+t2*t4*t6*abb84n54+t2*t4*t9*abb84n36+t3*t4*t6*abb84n52&
      &+t3*t4*t9*abb84n36+t4*t6*t7*abb84n52+t4*t6*t9*abb84n13)

      numerator = cmplx(real(d84, ki), aimag(d84), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d84h1l1
