module     p7_dubar_emnebargg_d92h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity1/d92h1l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram92_sign, shift => diagram92_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd92h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d92
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k2
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d92 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = t6*t6
      t8 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t11 = t3*abb92n24
      t12 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t14 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d92 = (abb92n1+t1*t11+t1*abb92n15+t11*t9+t2*abb92n17+t3*abb92n18+t3*t3*abb&
      &92n23+t4*abb92n2+t5*abb92n3+t6*abb92n5+t7*abb92n32+t8*abb92n42+t9*abb92n8&
      &+t1*t2*abb92n25+t1*t4*abb92n13+t1*t5*abb92n49+t1*t6*abb92n28+t1*t7*abb92n&
      &7+t1*t9*abb92n21+t10*t6*abb92n16+t12*t6*abb92n29+t13*t6*abb92n35+t13*t7*a&
      &bb92n36+t14*t2*abb92n45+t14*t3*abb92n44+t14*t6*abb92n41+t14*t7*abb92n56+t&
      &14*t9*abb92n43+t2*t3*abb92n22+t2*t4*abb92n19+t2*t6*abb92n31+t3*t4*abb92n2&
      &0+t3*t5*abb92n48+t3*t6*abb92n30+t3*t7*abb92n6+t4*t6*abb92n14+t4*t7*abb92n&
      &33+t4*t9*abb92n19+t5*t6*abb92n55+t5*t7*abb92n37+t6*t8*abb92n47+t6*t9*abb9&
      &2n27+t7*t8*abb92n39+t7*t9*abb92n7+t7*abb92n11*(Q(1)*spvak2k5(1)-Q(2)*spva&
      &k2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t7*abb92n34*(Q(1)*spvak2k4(1)-&
      &Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t1*t10*t6*abb92n12+t1&
      &*t14*t6*abb92n54+t1*t4*t6*abb92n26+t1*t5*t6*abb92n38+t10*t12*t6*abb92n9+t&
      &10*t3*t6*abb92n10+t10*t4*t6*abb92n4+t12*t14*t6*abb92n50+t12*t5*t6*abb92n4&
      &0+t13*t4*t6*abb92n46+t13*t4*t7*abb92n57+t14*t2*t6*abb92n52+t14*t3*t6*abb9&
      &2n51+t14*t6*t9*abb92n53+t2*t4*t6*abb92n26+t3*t4*t6*abb92n26+t3*t5*t6*abb9&
      &2n39+t4*t6*t9*abb92n26)
      numerator = cmplx(real(d92, ki), aimag(d92), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd92h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d92
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k2
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d92 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = t6*t6
      t8 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t11 = t3*abb92n24
      t12 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t14 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d92 = (abb92n1+t1*t11+t1*abb92n15+t11*t9+t2*abb92n17+t3*abb92n18+t3*t3*abb&
      &92n23+t4*abb92n2+t5*abb92n3+t6*abb92n5+t7*abb92n32+t8*abb92n42+t9*abb92n8&
      &+t1*t2*abb92n25+t1*t4*abb92n13+t1*t5*abb92n49+t1*t6*abb92n28+t1*t7*abb92n&
      &7+t1*t9*abb92n21+t10*t6*abb92n16+t12*t6*abb92n29+t13*t6*abb92n35+t13*t7*a&
      &bb92n36+t14*t2*abb92n45+t14*t3*abb92n44+t14*t6*abb92n41+t14*t7*abb92n56+t&
      &14*t9*abb92n43+t2*t3*abb92n22+t2*t4*abb92n19+t2*t6*abb92n31+t3*t4*abb92n2&
      &0+t3*t5*abb92n48+t3*t6*abb92n30+t3*t7*abb92n6+t4*t6*abb92n14+t4*t7*abb92n&
      &33+t4*t9*abb92n19+t5*t6*abb92n55+t5*t7*abb92n37+t6*t8*abb92n47+t6*t9*abb9&
      &2n27+t7*t8*abb92n39+t7*t9*abb92n7+t7*abb92n11*(Q(1)*spvak2k5(1)-Q(2)*spva&
      &k2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t7*abb92n34*(Q(1)*spvak2k4(1)-&
      &Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t1*t10*t6*abb92n12+t1&
      &*t14*t6*abb92n54+t1*t4*t6*abb92n26+t1*t5*t6*abb92n38+t10*t12*t6*abb92n9+t&
      &10*t3*t6*abb92n10+t10*t4*t6*abb92n4+t12*t14*t6*abb92n50+t12*t5*t6*abb92n4&
      &0+t13*t4*t6*abb92n46+t13*t4*t7*abb92n57+t14*t2*t6*abb92n52+t14*t3*t6*abb9&
      &2n51+t14*t6*t9*abb92n53+t2*t4*t6*abb92n26+t3*t4*t6*abb92n26+t3*t5*t6*abb9&
      &2n39+t4*t6*t9*abb92n26)

      numerator = cmplx(real(d92, ki), aimag(d92), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d92h1l1
