module     p7_dubar_emnebargg_d94h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity1/d94h1l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram94_sign, shift => diagram94_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd94h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d94
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k5
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d94 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = t1*t1
      t8 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = t3*abb94n21
      t11 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t12 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d94 = (abb94n1+t1*abb94n14+t10*t2+t10*t6+t2*abb94n15+t3*abb94n16+t3*t3*abb&
      &94n20+t4*abb94n17+t4*t4*abb94n22+t5*abb94n2+t6*abb94n3+t7*abb94n30+t8*abb&
      &94n4+t1*t12*abb94n40+t1*t2*abb94n23+t1*t3*abb94n28+t1*t4*abb94n27+t1*t5*a&
      &bb94n13+t1*t6*abb94n29+t1*t8*abb94n47+t1*t9*abb94n18+t11*t7*abb94n33+t12*&
      &t7*abb94n37+t13*t7*abb94n48+t2*t4*abb94n19+t2*t5*abb94n10+t2*t6*abb94n22+&
      &t2*t7*abb94n7+t2*t8*abb94n42+t3*t4*abb94n19+t3*t5*abb94n11+t3*t7*abb94n5+&
      &t3*t8*abb94n41+t4*t5*abb94n12+t4*t6*abb94n19+t4*t7*abb94n8+t4*t8*abb94n39&
      &+t5*t7*abb94n31+t7*t8*abb94n34+t7*t9*abb94n6+t7*abb94n32*(Q(1)*spvak2k4(1&
      &)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t7*abb94n9*(Q(1)*sp&
      &vak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t1*t13*t3*a&
      &bb94n44+t1*t13*t4*abb94n45+t1*t13*t6*abb94n43+t1*t2*t5*abb94n25+t1*t2*t8*&
      &abb94n38+t1*t3*t5*abb94n24+t1*t3*t8*abb94n36+t1*t4*t5*abb94n26+t1*t5*t6*a&
      &bb94n26+t1*t5*t8*abb94n46+t1*t8*t9*abb94n35+t11*t5*t7*abb94n49)
      numerator = cmplx(real(d94, ki), aimag(d94), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd94h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d94
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k5
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d94 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = t1*t1
      t8 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = t3*abb94n21
      t11 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t12 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d94 = (abb94n1+t1*abb94n14+t10*t2+t10*t6+t2*abb94n15+t3*abb94n16+t3*t3*abb&
      &94n20+t4*abb94n17+t4*t4*abb94n22+t5*abb94n2+t6*abb94n3+t7*abb94n30+t8*abb&
      &94n4+t1*t12*abb94n40+t1*t2*abb94n23+t1*t3*abb94n28+t1*t4*abb94n27+t1*t5*a&
      &bb94n13+t1*t6*abb94n29+t1*t8*abb94n47+t1*t9*abb94n18+t11*t7*abb94n33+t12*&
      &t7*abb94n37+t13*t7*abb94n48+t2*t4*abb94n19+t2*t5*abb94n10+t2*t6*abb94n22+&
      &t2*t7*abb94n7+t2*t8*abb94n42+t3*t4*abb94n19+t3*t5*abb94n11+t3*t7*abb94n5+&
      &t3*t8*abb94n41+t4*t5*abb94n12+t4*t6*abb94n19+t4*t7*abb94n8+t4*t8*abb94n39&
      &+t5*t7*abb94n31+t7*t8*abb94n34+t7*t9*abb94n6+t7*abb94n32*(Q(1)*spvak2k4(1&
      &)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t7*abb94n9*(Q(1)*sp&
      &vak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t1*t13*t3*a&
      &bb94n44+t1*t13*t4*abb94n45+t1*t13*t6*abb94n43+t1*t2*t5*abb94n25+t1*t2*t8*&
      &abb94n38+t1*t3*t5*abb94n24+t1*t3*t8*abb94n36+t1*t4*t5*abb94n26+t1*t5*t6*a&
      &bb94n26+t1*t5*t8*abb94n46+t1*t8*t9*abb94n35+t11*t5*t7*abb94n49)

      numerator = cmplx(real(d94, ki), aimag(d94), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d94h1l1
