module     p7_dubar_emnebargg_d89h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity3/d89h3l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram89_sign, shift => diagram89_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd89h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d89
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d89 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t7 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t8 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = t2*abb89n28
      t11 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t12 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t13 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t14 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      d89 = (t1*abb89n1+t10*t3+t10*t9+t2*abb89n2+t2*t2*abb89n27+t3*abb89n3+t1*t1&
      &2*abb89n4+t1*t13*abb89n5+t1*t2*abb89n9+t1*t3*abb89n10+t1*t4*abb89n10+t1*t&
      &5*abb89n11+t1*t7*abb89n8+t11*t2*abb89n30+t11*t3*abb89n31+t13*t2*abb89n6+t&
      &13*t3*abb89n7+t2*t6*abb89n13+t2*t7*abb89n14+t2*t8*abb89n16+t3*t6*abb89n12&
      &+t3*t7*abb89n15+t3*t8*abb89n17+t3*t9*abb89n26+t1*t11*t5*abb89n29+t1*t12*t&
      &2*abb89n23+t1*t12*t3*abb89n22+t1*t12*t4*abb89n22+t1*t12*t5*abb89n21+t1*t1&
      &3*t2*abb89n32+t1*t13*t3*abb89n33+t1*t13*t4*abb89n33+t1*t13*t5*abb89n34+t1&
      &*t14*t5*abb89n32+t1*t2*t5*abb89n20+t1*t2*t7*abb89n38+t1*t3*t7*abb89n37+t1&
      &*t4*t7*abb89n37+t1*t5*t7*abb89n39+t1*t5*t8*abb89n23+t1*t5*t9*abb89n19+t1*&
      &t5*abb89n18*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spva&
      &k2k4(4))+t13*t2*t6*abb89n36+t13*t3*t6*abb89n35+t14*t2*t6*abb89n40+t14*t3*&
      &t6*abb89n41+t2*t6*t8*abb89n24+t3*t6*t8*abb89n25+t1*t11*t5*t6*abb89n42)
      numerator = cmplx(real(d89, ki), aimag(d89), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd89h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d89
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d89 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t7 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t8 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = t2*abb89n28
      t11 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t12 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t13 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t14 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      d89 = (t1*abb89n1+t10*t3+t10*t9+t2*abb89n2+t2*t2*abb89n27+t3*abb89n3+t1*t1&
      &2*abb89n4+t1*t13*abb89n5+t1*t2*abb89n9+t1*t3*abb89n10+t1*t4*abb89n10+t1*t&
      &5*abb89n11+t1*t7*abb89n8+t11*t2*abb89n30+t11*t3*abb89n31+t13*t2*abb89n6+t&
      &13*t3*abb89n7+t2*t6*abb89n13+t2*t7*abb89n14+t2*t8*abb89n16+t3*t6*abb89n12&
      &+t3*t7*abb89n15+t3*t8*abb89n17+t3*t9*abb89n26+t1*t11*t5*abb89n29+t1*t12*t&
      &2*abb89n23+t1*t12*t3*abb89n22+t1*t12*t4*abb89n22+t1*t12*t5*abb89n21+t1*t1&
      &3*t2*abb89n32+t1*t13*t3*abb89n33+t1*t13*t4*abb89n33+t1*t13*t5*abb89n34+t1&
      &*t14*t5*abb89n32+t1*t2*t5*abb89n20+t1*t2*t7*abb89n38+t1*t3*t7*abb89n37+t1&
      &*t4*t7*abb89n37+t1*t5*t7*abb89n39+t1*t5*t8*abb89n23+t1*t5*t9*abb89n19+t1*&
      &t5*abb89n18*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spva&
      &k2k4(4))+t13*t2*t6*abb89n36+t13*t3*t6*abb89n35+t14*t2*t6*abb89n40+t14*t3*&
      &t6*abb89n41+t2*t6*t8*abb89n24+t3*t6*t8*abb89n25+t1*t11*t5*t6*abb89n42)

      numerator = cmplx(real(d89, ki), aimag(d89), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d89h3l1
