module     p7_dubar_emnebargg_d94h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity3/d94h3l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram94_sign, shift => diagram94_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd94h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d94
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k5
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d94 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t7 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t10 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t11 = t3*abb94n36
      t12 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d94 = (abb94n1+t1*abb94n2+t11*t4+t11*t8+t2*abb94n22+t2*t2*abb94n37+t3*abb9&
      &4n23+t3*t3*abb94n35+t4*abb94n24+t5*abb94n25+t6*abb94n3+t7*abb94n31+t8*abb&
      &94n7+t9*abb94n9+t1*t2*abb94n4+t1*t3*abb94n5+t1*t5*abb94n20+t1*t7*abb94n42&
      &+t1*t8*abb94n4+t1*t9*abb94n8+t10*t2*abb94n10+t10*t3*abb94n11+t10*t8*abb94&
      &n12+t12*t7*abb94n66+t2*t3*abb94n33+t2*t4*abb94n34+t2*t5*abb94n39+t2*t6*ab&
      &b94n14+t2*t7*abb94n44+t2*t8*abb94n32+t2*t9*abb94n65+t3*t5*abb94n50+t3*t6*&
      &abb94n15+t3*t7*abb94n45+t3*t9*abb94n64+t4*t5*abb94n21+t4*t6*abb94n16+t4*t&
      &7*abb94n43+t4*t8*abb94n38+t4*t9*abb94n63+t5*t6*abb94n17+t5*t7*abb94n52+t5&
      &*t8*abb94n51+t5*t9*abb94n74+t6*t7*abb94n18+t6*t8*abb94n6+t6*t9*abb94n13+t&
      &7*t8*abb94n46+t7*t9*abb94n19+t1*t12*t7*abb94n60+t1*t5*t7*abb94n27+t1*t5*t&
      &9*abb94n57+t10*t2*t5*abb94n77+t10*t2*t7*abb94n69+t10*t3*t5*abb94n76+t10*t&
      &3*t7*abb94n68+t10*t5*t7*abb94n78+t10*t5*t8*abb94n75+t10*t7*t8*abb94n67+t1&
      &2*t3*t7*abb94n61+t12*t4*t7*abb94n62+t12*t5*t7*abb94n56+t12*t6*t7*abb94n70&
      &+t13*t5*t7*abb94n55+t2*t5*t6*abb94n41+t2*t5*t7*abb94n29+t2*t6*t7*abb94n48&
      &+t2*t6*t9*abb94n71+t3*t5*t6*abb94n40+t3*t5*t7*abb94n26+t3*t5*t9*abb94n58+&
      &t3*t6*t7*abb94n47+t3*t6*t9*abb94n72+t4*t5*t7*abb94n28+t4*t5*t9*abb94n59+t&
      &4*t6*t7*abb94n49+t4*t6*t9*abb94n73+t5*t6*t7*abb94n53+t5*t6*t8*abb94n41+t5&
      &*t6*t9*abb94n79+t5*t7*t9*abb94n62+t5*t7*abb94n30*(Q(1)*spvak2k5(1)-Q(2)*s&
      &pvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t5*t7*abb94n54*(Q(1)*spvak2&
      &k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t6*t7*t8*abb94n&
      &48+t13*t5*t6*t7*abb94n80)
      numerator = cmplx(real(d94, ki), aimag(d94), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd94h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d94
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k5
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d94 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t7 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t10 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t11 = t3*abb94n36
      t12 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d94 = (abb94n1+t1*abb94n2+t11*t4+t11*t8+t2*abb94n22+t2*t2*abb94n37+t3*abb9&
      &4n23+t3*t3*abb94n35+t4*abb94n24+t5*abb94n25+t6*abb94n3+t7*abb94n31+t8*abb&
      &94n7+t9*abb94n9+t1*t2*abb94n4+t1*t3*abb94n5+t1*t5*abb94n20+t1*t7*abb94n42&
      &+t1*t8*abb94n4+t1*t9*abb94n8+t10*t2*abb94n10+t10*t3*abb94n11+t10*t8*abb94&
      &n12+t12*t7*abb94n66+t2*t3*abb94n33+t2*t4*abb94n34+t2*t5*abb94n39+t2*t6*ab&
      &b94n14+t2*t7*abb94n44+t2*t8*abb94n32+t2*t9*abb94n65+t3*t5*abb94n50+t3*t6*&
      &abb94n15+t3*t7*abb94n45+t3*t9*abb94n64+t4*t5*abb94n21+t4*t6*abb94n16+t4*t&
      &7*abb94n43+t4*t8*abb94n38+t4*t9*abb94n63+t5*t6*abb94n17+t5*t7*abb94n52+t5&
      &*t8*abb94n51+t5*t9*abb94n74+t6*t7*abb94n18+t6*t8*abb94n6+t6*t9*abb94n13+t&
      &7*t8*abb94n46+t7*t9*abb94n19+t1*t12*t7*abb94n60+t1*t5*t7*abb94n27+t1*t5*t&
      &9*abb94n57+t10*t2*t5*abb94n77+t10*t2*t7*abb94n69+t10*t3*t5*abb94n76+t10*t&
      &3*t7*abb94n68+t10*t5*t7*abb94n78+t10*t5*t8*abb94n75+t10*t7*t8*abb94n67+t1&
      &2*t3*t7*abb94n61+t12*t4*t7*abb94n62+t12*t5*t7*abb94n56+t12*t6*t7*abb94n70&
      &+t13*t5*t7*abb94n55+t2*t5*t6*abb94n41+t2*t5*t7*abb94n29+t2*t6*t7*abb94n48&
      &+t2*t6*t9*abb94n71+t3*t5*t6*abb94n40+t3*t5*t7*abb94n26+t3*t5*t9*abb94n58+&
      &t3*t6*t7*abb94n47+t3*t6*t9*abb94n72+t4*t5*t7*abb94n28+t4*t5*t9*abb94n59+t&
      &4*t6*t7*abb94n49+t4*t6*t9*abb94n73+t5*t6*t7*abb94n53+t5*t6*t8*abb94n41+t5&
      &*t6*t9*abb94n79+t5*t7*t9*abb94n62+t5*t7*abb94n30*(Q(1)*spvak2k5(1)-Q(2)*s&
      &pvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t5*t7*abb94n54*(Q(1)*spvak2&
      &k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t6*t7*t8*abb94n&
      &48+t13*t5*t6*t7*abb94n80)

      numerator = cmplx(real(d94, ki), aimag(d94), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d94h3l1
